package cost.speed;

import java.util.*;

/**
 * HashSet#contains()ArrayList#contains()̎sxr
 */
public class Contains {

	static HashMap hashMap = new HashMap();
	static ArrayList arrayList = new ArrayList();
	static Object[] array;

	static List keyList = new ArrayList();

	static final int PATTERN = 0;
	static final int[] SIZE = { 5, 16, 6 };
	static final int[] COUNT = { 500, 1000, 500 };

	public static void main(String[] args) {
		for (int i = 0; i < SIZE[PATTERN]; i++) {
			int size = i;
			int count = COUNT[PATTERN] * 10000;
			System.out.println("size=" + size + " count=" + count);
			if (size <= 1) {
				test(size, count);
				test(size, count);
			}
			test(size, count);
			test(size, count);
			test(size, count);
		}
	}

	static void test(int size, int count) {
		add(size);
		switch (PATTERN) {
		default:
			loopArray(count);
			loopArrayList(count);
			loopHashMap(count);
			break;
		case 1:
			firstArray(count);
			firstArrayList(count);
			firstHashMap(count);
			break;
		case 2:
			lastArray(count);
			lastArrayList(count);
			lastHashMap(count);
			break;
		}
	}

	static void add(int size) {
		for (int i = keyList.size(); i < size; i++) {
			// String key = Character.toString((char) ('A' + i));
			// String key = "ABCD" + Character.toString((char) ('A' + i));
			// String key = "ABCDE" + Character.toString((char) ('A' + i));
			Integer key = new Integer(i);
			keyList.add(key);

			hashMap.put(key, key);
			arrayList.add(key);
		}
		array = arrayList.toArray();
		Arrays.sort(array);

		System.gc();
		try {
			Thread.sleep(20);
		} catch (InterruptedException e) {
		}
	}

	static void print(String t, long s, long e) {
		System.out.println(t + ":\t" + (e - s));
	}

	static void loopHashMap(int count) {
		int size = keyList.size();
		long s = System.currentTimeMillis();
		for (int i = 0; i < count; i++) {
			for (int j = 0; j < size; j++) {
				Object key = keyList.get(j);
				hashMap.containsKey(key);
			}
		}
		long e = System.currentTimeMillis();
		print("HashMap  ", s, e);
	}

	static void loopArrayList(int count) {
		int size = keyList.size();
		long s = System.currentTimeMillis();
		for (int i = 0; i < count; i++) {
			for (int j = 0; j < size; j++) {
				Object key = keyList.get(j);
				arrayList.contains(key);
			}
		}
		long e = System.currentTimeMillis();
		print("ArrayList", s, e);
	}

	static void loopArray(int count) {
		int size = array.length;
		long s = System.currentTimeMillis();
		for (int i = 0; i < count; i++) {
			for (int j = 0; j < size; j++) {
				Object key = keyList.get(j);
				Arrays.binarySearch(array, key);
			}
		}
		long e = System.currentTimeMillis();
		print("array    ", s, e);
	}

	static void firstHashMap(int count) {
		Object key;
		try {
			key = keyList.get(0);
		} catch (IndexOutOfBoundsException e) {
			key = null;
		}

		long s = System.currentTimeMillis();
		for (int i = 0; i < count; i++) {
			hashMap.containsKey(key);
		}
		long e = System.currentTimeMillis();
		print("HashMap  ", s, e);
	}

	static void firstArrayList(int count) {
		Object key;
		try {
			key = keyList.get(0);
		} catch (IndexOutOfBoundsException e) {
			key = null;
		}

		long s = System.currentTimeMillis();
		for (int i = 0; i < count; i++) {
			arrayList.contains(key);
		}
		long e = System.currentTimeMillis();
		print("ArrayList", s, e);
	}

	static void firstArray(int count) {
		Object key;
		try {
			key = keyList.get(0);
		} catch (IndexOutOfBoundsException e) {
			key = null;
		}

		long s = System.currentTimeMillis();
		for (int i = 0; i < count; i++) {
			Arrays.binarySearch(array, key);
		}
		long e = System.currentTimeMillis();
		print("array    ", s, e);
	}

	static void lastHashMap(int count) {
		Object key;
		try {
			key = keyList.get(keyList.size() - 1);
		} catch (IndexOutOfBoundsException e) {
			key = null;
		}

		long s = System.currentTimeMillis();
		for (int i = 0; i < count; i++) {
			hashMap.containsKey(key);
		}
		long e = System.currentTimeMillis();
		print("HashMap  ", s, e);
	}

	static void lastArrayList(int count) {
		Object key;
		try {
			key = keyList.get(keyList.size() - 1);
		} catch (IndexOutOfBoundsException e) {
			key = null;
		}

		long s = System.currentTimeMillis();
		for (int i = 0; i < count; i++) {
			arrayList.contains(key);
		}
		long e = System.currentTimeMillis();
		print("ArrayList", s, e);
	}

	static void lastArray(int count) {
		Object key;
		try {
			key = keyList.get(keyList.size() - 1);
		} catch (IndexOutOfBoundsException e) {
			key = null;
		}

		long s = System.currentTimeMillis();
		for (int i = 0; i < count; i++) {
			Arrays.binarySearch(array, key);
		}
		long e = System.currentTimeMillis();
		print("array    ", s, e);
	}
}
