package cost.speed;

public class Instanceof {

	static final int COUNT = 100 * 10000;
	static final int DIV = 100;

	public static void main(String[] args) {
		_object();
		// _interface();
		// _class();
	}

	// C2IAObject_instanceof_C2 c instanceof Ci}b`j
	// C1AObject_instanceof_C2 c instanceof CiA}b`j
	// C2IAObject_instanceof_I c instanceof Ii}b`j
	// C1AObject_instanceof_I c instanceof IiA}b`j
	static void _object() {
		double sum = 0;
		for (int i = 0; i < 5; i++) {
			// C2ISub obj = new C2ISub();
			// C2I obj = new C2I();
			C1 obj = new C1();

			// sum += _Object_instanceof_C2(obj);
			sum += _Object_instanceof_Interface(obj);
		}
		System.out.println(sum / 5);
	}

	static void _interface() {
		double sum = 0;
		for (int i = 0; i < 5; i++) {
			I obj = new I() {
			};
			// C2I obj = new C2I();
			// C2ISub obj = new C2ISub();

			sum += _Interface_instanceof_C1(obj);
		}
		System.out.println(sum / 5);
	}

	static void _class() {
		double sum = 0;
		for (int i = 0; i < 5; i++) {
			// C1 obj = new C1();
			C2 obj = new C2();
			// C3 obj = new C3();

			sum += _C1_instanceof_C2(obj);
		}
		System.out.println(sum / 5);
	}

	static double _Interface_instanceof_C1(I obj) {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT * DIV; i++) {
			if (obj instanceof C1) {
			}
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("i_c: " + e / (double) DIV);
		return e / (double) DIV;
	}

	static double _Object_instanceof_Interface(Object obj) {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT * DIV; i++) {
			if (obj instanceof I) {
			}
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("o_i: " + e / (double) DIV);
		return e / (double) DIV;
	}

	static double _Object_instanceof_C2(Object obj) {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT * DIV; i++) {
			if (obj instanceof C2) {
			}
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("o_2: " + e / (double) DIV);
		return e / (double) DIV;
	}

	static double _C1_instanceof_C2(C1 obj) {
		long s = System.currentTimeMillis();
		for (int i = 0; i < COUNT * DIV; i++) {
			if (obj instanceof C2) {
			}
		}
		long e = System.currentTimeMillis();
		e -= s;
		System.out.println("1_2: " + e / (double) DIV);
		return e / (double) DIV;
	}
}

class C1 {

}

class C2 extends C1 {

}

class C3 extends C2 {

}

interface I {

}

class C2I extends C1 implements I {

}

class C2ISub extends C2I {

}
